﻿// Copyright (c) 2020 Tudor Stanciu

using AutoMapper;
using System.Linq;
using Tuitio.Application.Extensions;
using Tuitio.Application.Queries;
using Tuitio.Domain.Entities;

namespace Tuitio.Application.Mappings
{
    public class UserInfoMappings : Profile
    {
        public UserInfoMappings()
        {
            CreateMap<AppUser, GetUserInfo.Model>()
                .ForMember(z => z.Claims, src => src.MapFrom(z => z.Claims.ToDictionary()))
                .ForMember(z => z.UserGroups, src => src.MapFrom(z => z.UserGroups.Select(z => z.UserGroup)))
                .ForMember(z => z.UserRoles, src => src.MapFrom(z => z.GetUserRoles()));

            CreateMap<ContactOption, GetUserInfo.ContactOption>()
                .ForMember(z => z.Id, src => src.MapFrom(z => z.ContactOptionId))
                .ForMember(z => z.ContactTypeCode, src => src.MapFrom(z => z.ContactType.ContactTypeCode))
                .ForMember(z => z.ContactTypeName, src => src.MapFrom(z => z.ContactType.ContactTypeName));

            CreateMap<UserGroup, GetUserInfo.UserGroup>()
                .ForMember(z => z.Id, src => src.MapFrom(z => z.UserGroupId))
                .ForMember(z => z.Code, src => src.MapFrom(z => z.UserGroupCode))
                .ForMember(z => z.Name, src => src.MapFrom(z => z.UserGroupName));

            CreateMap<UserRole, GetUserInfo.UserRole>()
                .ForMember(z => z.Id, src => src.MapFrom(z => z.UserRoleId))
                .ForMember(z => z.Code, src => src.MapFrom(z => z.UserRoleCode))
                .ForMember(z => z.Name, src => src.MapFrom(z => z.UserRoleName));
        }
    }
}
