if not exists (select top 1 1 from sys.objects where name = 'UserXUserGroup' and type = 'U')
begin
    create table UserXUserGroup
    (
        UserId int not null constraint FK_UserXUserGroup_AppUser foreign key references AppUser(UserId),
        UserGroupId int not null constraint FK_UserXUserGroup_UserGroup foreign key references UserGroup(UserGroupId),
        constraint PK_UserXUserGroup primary key (UserId, UserGroupId)
    )
end

if not exists (select top 1 1 from sys.objects where name = 'UserGroupXUserRole' and type = 'U')
begin
	create table UserGroupXUserRole
	(
		UserGroupId int not null constraint FK_UserGroupXUserRole_UserGroup references UserGroup(UserGroupId),
		UserRoleId int not null constraint FK_UserGroupXUserRole_UserRole references UserRole(UserRoleId),
		constraint PK_UserGroupXUserRole primary key (UserGroupId, UserRoleId)
	)
end

if not exists (select top 1 1 from sys.objects where name = 'UserXUserRole' and type = 'U')
begin
	create table UserXUserRole
	(
		UserId int not null constraint FK_UserXUserRole_AppUser references AppUser(UserId),
		UserRoleId int not null constraint FK_UserXUserRole_UserRole references UserRole(UserRoleId),
		constraint PK_UserXUserRole primary key (UserId, UserRoleId)
	)
end